/* POPprxyd.cmd v1.0 */
/* POP3 proxy daemon */
/* Copyright (C) 2005 Jeroen Besse */

signal ON ERROR NAME verderhier;
signal ON FAILURE NAME verderhier;
signal ON HALT NAME verderhier;
/* signal ON NOVALUE NAME verderhier; */
signal ON SYNTAX NAME verderhier;
signal ON NOTREADY NAME verderhier;

rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
rc = SockLoadFuncs()

dlistenip= "127.0.0.1"
dlistenport= 110

parse arg server serverport listenip listenport profile

if listenip= "" then listenip= dlistenip
if listenport= "" then listenport= dlistenport

say "POP3 proxy daemon for profile" profile
say "Listening on" listenip":"listenport
say "Proxying to" server":"serverport

/* Initialize */
call charout , "SockInit, "
sockint= SockInit()
if sockint != 0 then
do
  say "INET.SYS probably not running"
  exit
end

call charout , "SockSocket, "
/* Get a client-side socket */
sc= SockSocket("AF_INET", "SOCK_STREAM", 0)
if sc< 0 then
do
  SockPSock_Errno("Socket()")
  exit
end

/* Bind the socket */
call charout , "SockBind, "
server.!family= "AF_INET"
server.!port= listenport
server.!addr= listenip
/* "INADDR_ANY" */
if SockBind(sc, server.!) < 0 then
do
  SockPSock_Errno("Bind()")
  exit
end

/* Listen */
call charout , "SockListen, "
if SockListen(sc, 1) != 0 then
do
  SockPSock_Errno("Listen()")
  exit
end

say "Waiting"
do forever

  /* Accept */
  ns= SockAccept(sc, server.!)
  if ns= -1 then
  do
    SockPSock_Errno("Accept()")
    rc= SockSoClose(sc)
    exit
  end

  rc = SockGetPeerName(ns,address.!)

  say date('s')' 'time('n')" Incoming call from "address.!addr", dispatching"

  "@start /c /b /max POPprxyw.cmd " ns server serverport profile

end

exit

verderhier:
say '--- Error on line 'SIGL'! Aborting.'
rc= SockSoClose(sc)
pause
