/* POPprxyw.cmd v1.0 */
/* POP3 proxy worker */
/* Copyright (C) 2005 Jeroen Besse */

signal ON ERROR NAME verderhier;
signal ON FAILURE NAME verderhier;
signal ON HALT NAME verderhier;
/* signal ON NOVALUE NAME verderhier; */
signal ON SYNTAX NAME verderhier;
signal ON NOTREADY NAME verderhier;

rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
rc = SockLoadFuncs()

newl= d2c(13)''d2c(10)
newl2= newl''newl
state= 0

parse arg ns servername port profile
if port= "" then port= 110
if profile= "" then profile= "default"

say "Incoming call"

say "SockSocket"
/* Get a client-side socket */
ss= SockSocket("AF_INET", "SOCK_STREAM", 0)
if ss< 0 then
do
  SockPSock_Errno("Socket()")
  exit
end

/* resolve server */
drop host.
rc = SockGetHostByName(servername, host.!)

/* Connect the socket */
say "SockConnect"
server.!family= "AF_INET"
server.!port= port
server.!addr= host.!addr
if SockConnect(ss, server.!) < 0 then
do
  SockPSock_Errno("Connect()")
  exit
end

/* Receive */
sessionclosed= 0
multiline= 0
do until sessionclosed

  /* eerst van server ... */
  /* say "C  P<-S" */
  received= 0
  tbuf= ""
  do until received
    drop buf
    rc= SockRecv(ss, buf, 25000000, 0)
    if rc = -1 then
    do
      SockPSock_Errno("Recv()")
      exit
    end
    if rc = 0 then
    do
      sessionclosed= 1
      received= 1
    end
    tbuf= tbuf''buf
    if left(tbuf,4)= "-ERR" then
      multiline= 0
    if multiline then
    do
      if right(buf,5)= newl'.'newl then
        received= 1
    end
    else
    do
      if right(buf,2)= newl then
        received= 1
    end
  end
  rcr= rc

  if state= 1 then
  do
    naam= 'RBL'right(random(0,100000,right(time('l'),6)),5,'0')'.tmp'
    call charout naam, tbuf
    call charout naam
/*
    p= pos(newl2, tbuf)
    bufh= left(tbuf, p- 1)
    bufm= substr(tbuf, p)

    call charout "test2.txt", tbuf''nelw2'.'newl
    tbuf= bufh''newl'X-RBLcPOPw: true'bufm
    call charout "test3.txt", tbuf
*/
    call RBLcheck naam' /p:'profile
    l= chars(naam)
    tbuf= charin(naam, 1, l)
    call charout naam
    state= 0
    "del "naam
  end
  rc= rcr

  /* ... naar client */
  if rc> 0 then
  do
    /* say "C<-P  S" */
    /* Send */
    if SockSend(ns, tbuf, 0) < 0 then
    do
      SockPSock_Errno("Send()")
      exit
    end
  end

  /* dan van client ... */
  /* say "C->P  S" */
  received= 0
  tbuf= ""
  do until received
    drop buf
    rc= SockRecv(ns, buf, 100, 0)
    if rc = -1 then
    do
      SockPSock_Errno("Recv()")
      exit
    end
    if rc = 0 then
    do
      sessionclosed= 1
      received= 1
    end
    tbuf= tbuf''buf
    if right(buf,2)= newl then
      received= 1
  end

  /* ... naar server */
  if rc> 0 then
  do
    multiline= 0
    parse var tbuf keyw param
    if keyw= "PASS" then
      say "C  P->S PASS ***"
    else
      if state= 0 then
        say "C  P->S "left(tbuf, length(tbuf)-2)
    if keyw= "LIST" then
      if words(param)= 0 then
        multiline= 1
    if keyw= "RETR" then
    do
      /* let's do some stuff here! */
      multiline= 1
      state= 1
    end
    if keyw= "TOP" then
      multiline= 1
    if keyw= "UIDL" then
      if words(param)= 0 then
        multiline= 1
    if keyw= "CAPA" then
      multiline= 1
    /* Send */
    if SockSend(ss, tbuf, 0) < 0 then
    do
      SockPSock_Errno("Send()")
      exit
    end
  end

end

say "Session closed"
rc= SockSoClose(ns)
rc= SockSoClose(ss)

/* pause */

exit

verderhier:
say '--- Error on line 'SIGL'! Aborting.'
rc= SockSoClose(ns)
rc= SockSoClose(ss)
pause
